> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.propexo.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.propexo.com/_mcp/server.

# Get all leases

GET https://api.propexo.com/v1/leases/

Get all leases

Reference: https://docs.propexo.com/api-reference/pms-generic-ap-is/leases/get-all-leases

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.propexo.com` (Production, default)
- `https://api.sandbox.propexo.com` (Sandbox)

## Request

### Query parameters

- `order-by` (string, optional, default: created_at:desc) — Order the results by a field. Optionally include asc or desc preceded by a colon (default is asc). Example: ?order-by=updated_at:desc
- `updated_at_gte` (string, optional, nullable) — Filter to records updated at or after this datetime. Format: ISO 8601 (e.g. 2026-01-01T00:00:00Z)
- `updated_at_lte` (string, optional, nullable) — Filter to records updated at or before this datetime. Format: ISO 8601 (e.g. 2026-12-31T23:59:59Z)
- `last_seen_gte` (string, optional, nullable) — Filter to records whose last_seen date is on or after this datetime. Format: ISO 8601 (e.g. 2026-01-01T00:00:00Z)
- `last_seen_lte` (string, optional, nullable) — Filter to records whose last_seen date is on or before this datetime. Format: ISO 8601 (e.g. 2026-12-31T23:59:59Z)
- `offset` (integer, optional, nullable, default: 0) — Can be used for paginating results
- `limit` (integer, optional, nullable, default: 100) — A number between 1 and 250 to determine the number of results to return in a single query
- `x_id` (string, optional) — The external lease id
- `x_property_id` (string, optional) — Deprecated: Use the Propexo property_id instead
- `x_unit_id` (string, optional) — Deprecated: Use the Propexo unit_id instead
- `location_id` (string, optional) — The Propexo unique identifier for the location associated with the property (exclusive to Rent Manager integrations). This is always null for non-Rent Manager integrations.
- `unit_id` (string, optional) — The Propexo unique identifier for the unit
- `resident_id` (string, optional) — The Propexo unique identifier for the resident. If you use this filter in conjunction with one of the move-in/move-out date filters, it will not be honored and will be overridden by the date filter.
- `property_id` (string, optional) — The Propexo unique identifier for the property
- `integration_id` (string, optional) — The Propexo unique identifier for the integration
- `before_move_in_date` (string, optional, nullable) — Filter to residents moving in before this date. Format: YYYY-MM-DD. Date filter combinations will act with AND logic on a single record.
- `after_move_in_date` (string, optional, nullable) — Filter to residents moving in after this date. Format: YYYY-MM-DD. Date filter combinations will act with AND logic on a single record.
- `before_move_out_date` (string, optional, nullable) — Filter to residents moving out before this date. Format: YYYY-MM-DD. Date filter combinations will act with AND logic on a single record.
- `after_move_out_date` (string, optional, nullable) — Filter to residents moving out after this date. Format: YYYY-MM-DD. Date filter combinations will act with AND logic on a single record.
- `only_null_move_outs` (V1LeasesGetParametersOnlyNullMoveOuts, optional) — Filter to only return leases where the move-out date is null
- `integration_vendor` (enum, optional) — The property management system of record
  - Allowed values: `APPFOLIO`, `BUILDIUM`, `ENTRATA`, `MRI`, `PROPERTYWARE`, `PROPERTYWARE_REST`, `REALPAGE`, `REALPAGE_RPX`, `RENTMANAGER`, `RENTVINE`, `RESMAN`, `YARDI`, `YARDI_REST`
- `status_normalized` (enum, optional) — The normalized status for the lease
  - Allowed values: `ACTIVE`, `INACTIVE`, `OTHER`, `PENDING`, `EVICTED`
- `status_raw` (string, optional) — The raw status associated with the lease
- `unit_number` (string, optional) — The unit number of the lease. When using this, the Propexo `property_id` filter must be added as well.

## Response

### 200

Successful response

- `meta` (ResponseMeta, required)
- `results` (list of Lease, required)

## Errors

### 400 Bad Request Error

Bad Request

- `error` (ErrorResponseError, required)

## Types

### V1LeasesGetParametersOnlyNullMoveOuts

Filter to only return leases where the move-out date is null

### ResponseMeta

- `orderBy` (list of ResponseMetaOrderByItems, required)
- `offset` (integer, optional) — The offset of the first result
- `limit` (integer, optional) — The number of results to return
- `hasMore` (boolean, optional, nullable) — Whether there are more results
- `total` (integer, optional) — The total number of results

### Lease

- `id` (string, required) — The Propexo unique identifier for the lease
- `created_at` (string, required) — The date record first entered Propexo
- `updated_at` (string, required) — The date record was last updated in Propexo
- `last_seen` (string, required, nullable) — The date the record was last seen from the PMS
- `x_id` (string, required) — The external ID from the integration vendor
- `x_property_id` (string, required) — The external ID of the property from the integration vendor
- `x_unit_id` (string, required, nullable) — The external ID of the unit from the integration vendor
- `application_date` (string, required, nullable) — The application date associated with the lease
- `custom_data` (LeaseCustomData, required, nullable)
- `deposit_amount` (string, required, nullable) — The deposit amount associated with the lease
- `deposit_amount_in_cents` (double, required, nullable) — The deposit amount in cents associated with the lease
- `deposit_date` (string, required, nullable) — The deposit date associated with the lease
- `end_date` (string, required, nullable) — The end date associated with the lease
- `rent_amount_in_cents` (double, required, nullable) — The rent amount in cents for the lease
- `rent_amount_market_in_cents` (double, required, nullable) — The market rent amount in cents for the lease
- `rent_due_day` (integer, required, nullable) — The rent due day associated with the lease
- `rent_due_date` (string, required, nullable) — The rent due date associated with the lease
- `signature_date` (string, required, nullable) — The date the lease was signed
- `start_date` (string, required, nullable) — The start date associated with the lease
- `status_normalized` (enum, required) — The normalized status for the lease. Note that the status may be called "EVICTED" but this can also refer to an active resident undergoing a current eviction. This varies per PMS.
  - Allowed values: `ACTIVE`, `INACTIVE`, `OTHER`, `PENDING`, `EVICTED`
- `status_raw` (string, required, nullable) — The raw status associated with the lease
- `term` (string, required, nullable) — The lease term
- `type` (string, required, nullable) — The type of lease
- `unit_number` (string, required, nullable) — The unit number associated with the lease. This isn't always provided by PMS vendors, but may be the only data provided to identify a unit associated with a service request in some cases.
- `write_off_amount_in_cents` (double, required, nullable) — The write off amount for the lease, in cents
- `write_off_amount_raw` (string, required, nullable) — The raw write off amount of the lease from the PMS
- `balance_amount_in_cents` (double, required, nullable) — The balance amount for the lease, in cents
- `balance_amount_raw` (string, required, nullable) — The raw balance amount of the lease from the PMS
- `past_due_balance_in_cents` (double, required, nullable) — The past due balance for the lease, in cents
- `past_due_balance_raw` (string, required, nullable) — The raw past due balance of the lease from the PMS
- `unit_id` (string, required, nullable) — The Propexo unique identifier for the unit
- `property_id` (string, required) — The Propexo unique identifier for the property
- `integration_id` (string, required) — The Propexo unique identifier for the integration
- `integration_vendor` (enum, required) — The property management system of record
  - Allowed values: `APPFOLIO`, `BUILDIUM`, `ENTRATA`, `MRI`, `PROPERTYWARE`, `PROPERTYWARE_REST`, `REALPAGE`, `REALPAGE_RPX`, `RENTMANAGER`, `RENTVINE`, `RESMAN`, `YARDI`, `YARDI_REST`
- `services` (list of LeaseServicesItems, required)
- `x_resident_id` (string, required, nullable, deprecated) — Deprecated. Use residents_meta_data instead
- `realized_move_in_date` (string, required, nullable, deprecated) — DEPRECATED: Please use residents_meta_data to view resident move in dates
- `realized_move_out_date` (string, required, nullable, deprecated) — DEPRECATED: Please use residents_meta_data to view resident move out dates
- `scheduled_move_in_date` (string, required, nullable, deprecated) — DEPRECATED: Please use residents_meta_data to view resident move in dates
- `scheduled_move_out_date` (string, required, nullable, deprecated) — DEPRECATED: Please use residents_meta_data to view resident move out dates
- `status` (string, required, nullable, deprecated) — DEPRECATED. Use status_normalized
- `residents_meta_data` (list of LeaseResidentsMetaDataItems, optional)

### ErrorResponseError

- `code` (string, required)
- `message` (string, required)
- `details` (map from string to any, optional)

### ResponseMetaOrderByItems

### LeaseCustomData

### LeaseServicesItems

- `id` (string, required) — The Propexo unique identifier for the lease service
- `created_at` (string, required) — The date record first entered Propexo
- `updated_at` (string, required) — The date record was last updated in Propexo
- `last_seen` (string, required) — The date the record was last seen from the PMS
- `name` (string, required) — The name of the lease service
- `lease_id` (string, required) — The Propexo unique identifier for the lease

### LeaseResidentsMetaDataItems

- `resident_id` (string, required) — The Propexo unique identifier for the resident
- `x_resident_type` (string, required, nullable) — The external type of the resident from the integration vendor
- `resident_type_normalized` (LeaseResidentsMetaDataItemsResidentTypeNormalized, required, nullable) — Resident type from Propexo
- `move_in_date` (string, required, nullable) — The move-in date associated with the resident
- `move_out_date` (string, required, nullable) — The move-out date associated with the resident
- `notice_date` (string, required, nullable) — The date the resident gave notice
- `custom_data` (LeaseResidentsMetaDataItemsCustomData, required, nullable)
- `last_seen` (string, required, nullable) — The date the record was last seen from the PMS

### LeaseResidentsMetaDataItemsResidentTypeNormalized

Resident type from Propexo

### LeaseResidentsMetaDataItemsCustomData

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "meta": {
    "orderBy": [
      {}
    ],
    "offset": 0,
    "limit": 100,
    "hasMore": true,
    "total": 1000
  },
  "results": [
    {
      "id": "a1b2c3d4-e5f6-7890-ab12-cd34ef567890",
      "created_at": "2023-11-01T09:15:00Z",
      "updated_at": "2024-05-20T16:45:00Z",
      "last_seen": "2024-05-20T16:45:00Z",
      "x_id": "EXT-LEASE-987654",
      "x_property_id": "EXT-PROP-123456",
      "x_unit_id": "EXT-UNIT-112233",
      "application_date": "2023-10-15T00:00:00Z",
      "custom_data": {},
      "deposit_amount": "1500.00",
      "deposit_amount_in_cents": 150000,
      "deposit_date": "2023-10-20T00:00:00Z",
      "end_date": "2024-11-30T00:00:00Z",
      "rent_amount_in_cents": 150000,
      "rent_amount_market_in_cents": 160000,
      "rent_due_day": 1,
      "rent_due_date": "2024-06-01T00:00:00Z",
      "signature_date": "2023-10-25T00:00:00Z",
      "start_date": "2023-12-01T00:00:00Z",
      "status_normalized": "ACTIVE",
      "status_raw": "Active Lease",
      "term": "12 months",
      "type": "Residential",
      "unit_number": "12B",
      "write_off_amount_in_cents": 0,
      "write_off_amount_raw": "0.00",
      "balance_amount_in_cents": 0,
      "balance_amount_raw": "0.00",
      "past_due_balance_in_cents": 0,
      "past_due_balance_raw": "0.00",
      "unit_id": "unit-44556677-8899-aabb-ccdd-eeff00112233",
      "property_id": "prop-99887766-5544-3322-1100-aabbccddeeff",
      "integration_id": "int-1234abcd-5678-efgh-9012-ijklmnopqrst",
      "integration_vendor": "APPFOLIO",
      "services": [
        {
          "id": "service-abc12345-def6-7890-gh12-ijklmnopqrst",
          "created_at": "2023-11-01T09:15:00Z",
          "updated_at": "2024-05-20T16:45:00Z",
          "last_seen": "2024-05-20T16:45:00Z",
          "name": "Parking Space Rental",
          "lease_id": "a1b2c3d4-e5f6-7890-ab12-cd34ef567890"
        }
      ],
      "x_resident_id": "EXT-RES-654321",
      "realized_move_in_date": null,
      "realized_move_out_date": null,
      "scheduled_move_in_date": null,
      "scheduled_move_out_date": null,
      "status": null,
      "residents_meta_data": [
        {
          "resident_id": "res-00112233-4455-6677-8899-aabbccddeeff",
          "x_resident_type": "Primary Tenant",
          "resident_type_normalized": "PRIMARY",
          "move_in_date": "2023-12-01T00:00:00.000Z",
          "move_out_date": null,
          "notice_date": null,
          "custom_data": {},
          "last_seen": "2024-05-20T16:45:00Z"
        }
      ]
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.propexo.com/v1/leases/"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.propexo.com/v1/leases/';
const options = {
  method: 'GET',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.propexo.com/v1/leases/"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.propexo.com/v1/leases/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.propexo.com/v1/leases/")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.propexo.com/v1/leases/', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.propexo.com/v1/leases/");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.propexo.com/v1/leases/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```